Enumeration
  #Window
  #Camera
  #Material
  #Mesh
  #Entity
EndEnumeration

If InitEngine3D(#PB_Engine3D_DebugLog) = 0
  End
EndIf
If InitSprite() = 0
  End
EndIf
If InitKeyboard() = 0
  End
EndIf
 
ExamineDesktops()
Define.i DesktopW = DesktopWidth(0)
Define.i DesktopH = DesktopHeight(0)

Define.d Z
Define.i Event
Define.i Quit

If OpenWindow(#Window, 0, 0, DesktopW, DesktopH, "Material LOD")
  If OpenWindowedScreen(WindowID(#Window), 0, 0, DesktopW, DesktopH, 0, 0, 0)

    Add3DArchive("Textures", #PB_3DArchive_FileSystem)
    Add3DArchive("Scripts", #PB_3DArchive_FileSystem)
    Parse3DScripts()
    
    GetScriptMaterial(#Material, "Material_LOD")
    
    CreateCube(#Mesh, 10)
    CreateEntity(#Entity, MeshID(#Mesh), MaterialID(#Material))
    
    CreateCamera(#Camera, 0, 0, 100, 100)
    MoveCamera(#Camera, 0, 0, 10, #PB_Absolute)
    CameraLookAt(#Camera,0,0,0)
    CameraBackColor(#Camera,RGB(20,20,20))
        
    Repeat
      Event = WindowEvent()
      
      If ExamineKeyboard()
        If KeyboardPushed(#PB_Key_Up)
          Z = -0.2
        ElseIf KeyboardPushed(#PB_Key_Down)
          Z = 0.2
        Else
          Z = 0
        EndIf
        
        If KeyboardReleased(#PB_Key_Escape)
          Quit = 1
        EndIf
      EndIf

      MoveCamera(#Camera, 0, 0, Z, #PB_Relative)

      RenderWorld()
      FlipBuffers()

    Until Quit = 1 Or Event = #PB_Event_CloseWindow
  EndIf
EndIf
End

; IDE Options = PureBasic 5.42 LTS (Windows - x86)
; CursorPosition = 27
; FirstLine = 20
; EnableXP
; CompileSourceDirectory